import { Observable } from 'rxjs/Rx';
import { EventEmitter } from '@angular/core';
export declare class TwilioVideoService {
    onDetachTrack: EventEmitter<{}>;
    onRemoteVideoAttach: EventEmitter<{}>;
    onLocalVideoAttach: EventEmitter<{}>;
    constructor();
    attachTrackToLocal(track: Track, selector?: string): void;
    attachTrackToRemote(track: Track, selector?: string): void;
    detachTracksFromLocal(): void;
    detachTracksFromRemote(): void;
    createLocalTracks(options?: LocalTrackOptions): Observable<Track[]>;
    connect(token: string, options: ConnectOptions): Observable<Room>;
}
export declare class Room {
    _nativeObject: any;
    participants: Array<Participant>;
    onParticipantConnected: EventEmitter<Participant>;
    onParticipantDisconnected: EventEmitter<Participant>;
    onDisconnect: EventEmitter<Room>;
    constructor(_nativeObject: any);
    disconnect(): void;
}
export declare class Participant {
    _nativeObject: any;
    onTrackAdded: EventEmitter<{}>;
    tracks: Array<Track>;
    constructor(_nativeObject: any);
}
export declare class Track {
    _nativeObject: any;
    id: string;
    kind: string;
    name: string;
    constructor(_nativeObject: any);
    attach(selector?: string): any;
    stop(): void;
}
export interface LocalTrackOptions {
    audio?: boolean;
    logLevel?: string;
    video?: boolean | {
        width?: number;
        height?: number;
    };
}
export interface ConnectOptions {
    audio?: boolean | LocalTrackOptions;
    iceServers?: Array<any>;
    iceTransportPolicy?: string;
    insights?: boolean;
    maxAudioBitrate?: number;
    maxVideoBitrate?: number;
    name?: string;
    preferredAudioCodecs?: Array<any>;
    preferredVideoCodecs?: Array<any>;
    logLevel?: any;
    tracks?: Array<any>;
    video?: boolean | LocalTrackOptions;
}
